<template>
	<div class="auxiliary-business-tag-container layout-padding">
		<div class="layout-padding-auto layout-padding-view pd20">
			<el-form :model="state.queryParams" ref="ruleFormRef" inline @submit.native.prevent>
				<el-form-item label="关键字" prop="Keyword">
					<el-input v-model="state.queryParams.Keyword" placeholder="标签名称 " clearable @keyup.enter="handleQuery" class="keyword-input" />
				</el-form-item>
				<el-form-item label="标签类型" prop="Type">
					<el-select v-model="state.queryParams.Type" placeholder="请选择标签类型" @change="handleQuery">
						<el-option v-for="item in tagType" :value="item.key" :key="item.key" :label="item.value" />
					</el-select>
				</el-form-item>
				<el-form-item label="业务类型" prop="BusinessType">
					<el-select v-model="state.queryParams.BusinessType" placeholder="请选择业务类型" @change="handleQuery">
						<el-option v-for="item in businessTagType" :value="item.key" :key="item.key" :label="item.value" />
					</el-select>
				</el-form-item>
				<el-form-item>
					<el-button type="primary" @click="handleQuery" :loading="state.loading"> <SvgIcon name="ele-Search" class="mr5" />查询 </el-button>
					<el-button @click="resetQuery(ruleFormRef)" class="default-button"> <SvgIcon name="ele-Refresh" class="mr5" />重置 </el-button>
				</el-form-item>
			</el-form>
			<vxe-toolbar
				ref="toolbarRef"
				:loading="state.loading"
				custom
				:refresh="{
					queryMethod: handleQuery,
				}"
			>
				<template #buttons>
					<el-button type="primary" @click="addParameter" v-auth="'auxiliary:businessTag:add'">
						<SvgIcon name="ele-Plus" class="mr5" />新增业务标签
					</el-button>
					<el-button type="danger" @click="businessTagRemove" v-auth="'auxiliary:businessTag:delete'" :disabled="isChecked">
						<SvgIcon name="ele-Delete" class="mr5" />删除
					</el-button>
					<el-button type="info" @click="businessTagBinding" v-auth="'auxiliary:businessTag:binding'" :disabled="isChecked">
						<SvgIcon name="ele-Link" class="mr5" />批量绑定
					</el-button>
				</template>
			</vxe-toolbar>
			<div style="overflow: hidden; width: 100%; height: 100%; flex: 1">
				<vxe-table
					border
					:loading="state.loading"
					:data="state.tableData"
					:column-config="{ resizable: true, useKey: true }"
					:row-config="{ isCurrent: true, isHover: true, useKey: true, height: 30 }"
					ref="tableRef"
					height="auto"
					auto-resize
					show-overflow
					:scrollY="{ enabled: true, gt: 100 }"
					id="auxiliaryBusinessTag"
					:custom-config="{ storage: true }"
					@checkbox-all="selectAllChangeEvent"
					@checkbox-change="selectChangeEvent"
				>
					<vxe-column type="checkbox" width="60" align="center"></vxe-column>
					<vxe-column field="name" title="标签名称" min-width="200"></vxe-column>
					<vxe-column field="typeText" title="标签类型" min-width="150"></vxe-column>
					<vxe-column field="businessTypeText" title="业务类型" min-width="150"></vxe-column>
					<vxe-column field="classify" title="分类名称" min-width="150"></vxe-column>
					<vxe-column field="creatorName" title="创建人" min-width="120"></vxe-column>
					<vxe-column field="creatorOrgName" title="创建部门" min-width="140"></vxe-column>
					<vxe-column field="creationTime" title="创建时间" width="160">
							<template #default="{ row }">
								{{ formatDate(row.creationTime, 'YYYY-mm-dd HH:MM:SS') }}
							</template>
					</vxe-column>
					<vxe-column title="操作" fixed="right" width="120" align="center">
						<template #default="{ row }">
							<el-button link type="primary" @click="updateBusinessTag(row)" v-auth="'auxiliary:businessTag:edit'" title="修改业务标签">
								编辑
							</el-button>
							<el-button link type="info" @click="viewBusinessTag(row)" title="查看详情"> 查看 </el-button>
						</template>
					</vxe-column>
				</vxe-table>
			</div>
			<pagination
				@pagination="queryList"
				:total="state.total"
				v-model:current-page="state.queryParams.PageIndex"
				v-model:page-size="state.queryParams.PageSize"
				:disabled="state.loading"
			/>
		</div>
		<!--  新增标签  -->
		<business-tag-add ref="businessTagAddRef" @updateList="queryList" :businessTagType="businessTagType" :tagType="tagType" />
		<!--  编辑标签  -->
		<business-tag-edit ref="businessTagEditRef" @updateList="queryList" :businessTagType="businessTagType" :tagType="tagType" />
		<!--  批量绑定  -->
		<business-tag-binding-com ref="businessTagBindingRef" @updateList="queryList" />
	</div>
</template>

<script lang="tsx" setup name="auxiliaryBusinessTag">
import { computed, defineAsyncComponent, onMounted, reactive, ref } from 'vue';
import { ElMessage, ElMessageBox, FormInstance } from 'element-plus';
import { businessTagBaseData, businessTagDelete, businessTagList } from '@/api/auxiliary/businessTag';
import { formatDate } from '@/utils/formatTime';
// 引入组件
const BusinessTagBindingCom = defineAsyncComponent(() => import('@/views/auxiliary/businessTag/components/Business-tag-binding.vue')); // 绑定标签
const BusinessTagAdd = defineAsyncComponent(() => import('@/views/auxiliary/businessTag/components/Business-tag-add.vue')); // 新增标签
const BusinessTagEdit = defineAsyncComponent(() => import('@/views/auxiliary/businessTag/components/Business-tag-edit.vue')); // 编辑标签
const pagination = defineAsyncComponent(() => import('@/components/ProTable/components/Pagination.vue')); // 分页

// 定义变量内容
const state = reactive<any>({
	loading: false, // 加载状态
	queryParams: {
		// 查询参数
		PageIndex: 1,
		PageSize: 20,
		Keyword: null, // 参数名称
		Type: null, // 标签类型
		BusinessType: null, // 业务类型
	},
	total: 0, // 总条数
	tableData: [], // 表格数据
});
const ruleFormRef = ref<any>(null); // 表单ref
const businessTagType = ref<EmptyArrayType>(); // 业务类型
const tagType = ref<EmptyArrayType>(); // 标签类型
// 获取基础数据
const getBaseData = async () => {
	try {
		const res = await businessTagBaseData();
		businessTagType.value = res.result?.businessTagType ?? [];
		tagType.value = res.result?.tagType ?? [];
	} catch (error) {
		console.log(error);
	}
};
/** 搜索按钮操作 */
const handleQuery = () => {
	state.queryParams.PageIndex = 1;
	queryList();
};
// 获取列表
const queryList = () => {
	state.loading = true;
	businessTagList(state.queryParams)
		.then((res) => {
			state.loading = false;
			state.tableData = res.result.items ?? [];
			state.total = res.result.total ?? 0;
			tableRef.value.clearCheckboxRow();
			checkTable.value = [];
		})
		.finally(() => {
			state.loading = false;
			tableRef.value.clearCheckboxRow();
			checkTable.value = [];
		});
};
// 重置表单
const resetQuery = (formEl: FormInstance | undefined) => {
	if (!formEl) return;
	formEl.resetFields();
	queryList();
};
// 新增标签
const businessTagAddRef = ref<RefType>(); // 新增标签
const addParameter = () => {
	businessTagAddRef.value.openDialog();
};
// 修改标签
const businessTagEditRef = ref<RefType>(); // 修改标签
const updateBusinessTag = (row: any) => {
	businessTagEditRef.value.openDialog(row.id);
};
// 查看详情
const viewBusinessTag = (row: any) => {
	businessTagEditRef.value.openDialog(row.id, true);
};
// 删除标签
const businessTagRemove = () => {
	const ids = checkTable.value.map((item: any) => item.id);
	ElMessageBox.confirm(`您确定要删除选中的业务标签，是否继续?`, '提示', {
		confirmButtonText: '确认',
		cancelButtonText: '取消',
		type: 'warning',
		draggable: true,
		cancelButtonClass: 'default-button',
		autofocus: false,
	})
		.then(() => {
			businessTagDelete({ ids }).then(() => {
				ElMessage.success('操作成功');
				queryList();
			});
		})
		.catch(() => {});
};
// 批量绑定
const businessTagBindingRef = ref<RefType>(); // 绑定ref
const businessTagBinding = () => {
	const ids = checkTable.value.map((item: any) => item.id);
	businessTagBindingRef.value.openDialog(ids);
};
const tableRef = ref<RefType>();
const checkTable = ref<EmptyArrayType>([]);
const selectAllChangeEvent = ({ checked }) => {
	if (tableRef.value) {
		const records = tableRef.value.getCheckboxRecords();
		checkTable.value = records;
		console.log(checked ? '所有勾选事件' : '所有取消事件', records);
	}
};

const selectChangeEvent = ({ checked }) => {
	if (tableRef.value) {
		const records = tableRef.value.getCheckboxRecords();
		checkTable.value = records;
		console.log(checked ? '勾选事件' : '取消事件', records);
	}
};
const isChecked = computed(() => {
	return !Boolean(checkTable.value.length);
});
const toolbarRef = ref<RefType>();
// 页面加载时
onMounted(() => {
	queryList();
	if (tableRef.value && toolbarRef.value) {
		tableRef.value.connect(toolbarRef.value);
	}
	getBaseData();
});
</script>
